/*
 * com.simulogic.dataview -- The Java2D Plotting Framework
 * 
 * Copyright (C) 1999 - 2005 Sergey Missan
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this library; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 */

package com.simulogic.dataview.actions;

/**
 * AxisZoomIn action implementation
 */
public class AxisZoomInAction extends com.simulogic.utils.ActionSupport {

    private com.simulogic.dataview.DataAxis axis;

    /**
     * Creates new action
     * 
     * @param a axis
     */
    public AxisZoomInAction(com.simulogic.dataview.DataAxis a) {
        this();
        axis = a;
    }

    /**
     * Creates new action
     */
    public AxisZoomInAction() {
        super(com.simulogic.dataview.ResourceManager.getResource("Zoom_In_x2"),
                com.simulogic.dataview.ResourceManager.getResource("Zoom_in"));
    }

    /**
     * Action interface implementation
     * 
     * @param evt event
     */
    public void actionPerformed(java.awt.event.ActionEvent evt) {
        axis.zoomCentered(2.0);
    }
}