<?xml version="1.0"?>
<xsl:stylesheet  version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:math="http://www.w3.org/1998/Math/MathML" >

	<xsl:strip-space elements="*"/>

	<xsl:template match="math:apply" name="complex-apply" mode="complex-cartesian">
	<xsl:choose>
	    <xsl:when test="./*[position()=1 and name()='sep']">
		<xsl:for-each select="./*[position()&gt;1]">
		<xsl:apply-templates select="." mode="complex-cartesian"/>;
		</xsl:for-each>
	    </xsl:when>
	    <xsl:when test="position()&lt;3">
		<xsl:apply-templates select="./*[position()=1]" mode="complex-cartesian"/>
		<xsl:if test="parent::*[name()='math']">;
		</xsl:if>
	    </xsl:when>
	    <xsl:when test="not(../*[position()=1 and local-name()='eq'] and ../*[2]/*[position()=1 and local-name()='csymbol'])">
		<xsl:apply-templates select="./*[position()=1]" mode="complex-cartesian"/>
		<xsl:if test="parent::*[name()='math']">;
		</xsl:if>
	    </xsl:when>
            <xsl:otherwise>
            <xsl:text>/*</xsl:text><xsl:value-of select="./*[1]"/><xsl:text>*/</xsl:text>
            </xsl:otherwise>
	</xsl:choose>
	</xsl:template>
	<xsl:template match="math:eq" name="complex-eq" mode="complex-cartesian">
	<xsl:param name="eqvar" select="'='"/>
		<xsl:choose>
		<xsl:when test="../*[2]/*[position()=1 and local-name()='csymbol']">
			<xsl:apply-templates select="../*[2]" mode="complex-cartesian">
					<xsl:with-param name="eqvar" select="' '"/>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test="parent::math:apply/*[position()=3 and local-name()='piecewise']">
			<xsl:apply-templates select="parent::math:apply/*[3]" mode="complex-cartesian">
			</xsl:apply-templates>
		</xsl:when>
		<xsl:otherwise>
		<xsl:for-each select="parent::math:apply/*[position()>1]">
			<xsl:if test="position()=2 or (not(position()=1) and not(../../../*[2]/*[position()=1 and local-name()='csymbol']))">
				<xsl:value-of select="$eqvar"/>
			</xsl:if>
			<xsl:apply-templates select="." mode="complex-cartesian"/>
		</xsl:for-each>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="math:and" name="complex-and" mode="complex-cartesian">
                <xsl:text>(</xsl:text>
                <xsl:for-each select="parent::math:apply/*[position()>1]">
                        <xsl:if test="not(position()=1)">
                                <xsl:text> &amp;&amp; </xsl:text>
                        </xsl:if>
                        <xsl:apply-templates select="." mode="complex-cartesian"/>
                </xsl:for-each>
                <xsl:text>)</xsl:text>
	</xsl:template>
	<xsl:template match="math:in" name="complex-in" mode="complex-cartesian">
            <xsl:choose>
                <xsl:when test="../*[position()=3 and name()='complexes']">
                    <xsl:text>com.pombi.mathml.lang.ComplexDouble.isComplex(</xsl:text>
                    <xsl:apply-templates select="../*[2]" mode="complex-cartesian"/>
                    <xsl:text>)</xsl:text>
                </xsl:when>
            </xsl:choose>
	</xsl:template>
	<xsl:template match="math:plus" name="complex-plus" mode="complex-cartesian">
            <xsl:choose>
                <xsl:when test="../*[position()=2 and not(@type='complex-cartesian')] and ../*[position()=3 and not(@type='complex-cartesian')]">
                        <xsl:call-template name="plus"/>
                </xsl:when>
                <xsl:otherwise>
                <xsl:text>(</xsl:text>
                <xsl:for-each select="parent::math:apply/*[position()>1]">
                        <xsl:if test="not(position()=1)">
                                <xsl:text>.plus(</xsl:text>
                        </xsl:if>
                        <xsl:apply-templates select="." mode="complex-cartesian"/>
                        <xsl:if test="not(position()=1)">
                                <xsl:text>)</xsl:text>
                        </xsl:if>
                </xsl:for-each>
                <xsl:text>)</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
	</xsl:template>
	<xsl:template match="math:ci" name="complex-ci" mode="complex-cartesian">
            <xsl:choose>
                <xsl:when test="not(@type='complex-cartesian')">
                        <xsl:call-template name="ci"/>
                </xsl:when>
                <xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mn']">
                        <xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/>[(int)<xsl:value-of select="translate(./*[1]/*[2],' ','')"/><xsl:text>]</xsl:text>
                </xsl:when>
                <xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mi']">
                        <xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/>[(int)<xsl:value-of select="translate(./*[1]/*[2],' &#9;&#10;&#13;','')"/><xsl:text>]</xsl:text>
                </xsl:when>
                <xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='apply']">
                        <xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/>[(int)<xsl:apply-templates select="./*[1]/*[2]" mode="complex-cartesian"/><xsl:text>]</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                        <xsl:value-of select="translate(.,' &#9;&#10;&#13;','')"/>
                </xsl:otherwise>
            </xsl:choose>
	</xsl:template>
	<xsl:template match="math:cn" name="complex-cn" mode="complex-cartesian">
            <xsl:choose>
                <xsl:when test="not(@type='complex-cartesian')">
                        <xsl:call-template name="ci"/>
                </xsl:when>
                <xsl:otherwise>
		<xsl:text>new com.pombi.mathml.lang.ComplexDouble(new double[]{</xsl:text><xsl:value-of select="text()"/>, <xsl:value-of select="substring(string(.),string-length(text())+1)"/><xsl:text>})</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
	</xsl:template>
	<xsl:template match="math:divide" name="complex-divide" mode="complex-cartesian">
		<xsl:apply-templates select="parent::math:apply/*[2]" mode="complex-cartesian"/>
				<xsl:text>.dividedBy(</xsl:text>
		<xsl:apply-templates select="parent::math:apply/*[3]" mode="complex-cartesian"/>
				<xsl:text>)</xsl:text>
	</xsl:template>
	<xsl:template match="math:quotient" name="complex-quotient" mode="complex-cartesian">
		<xsl:for-each select="parent::math:apply/*[position()>1]">
			<xsl:if test="not(position()=1)">
				<xsl:text>.dividedBy(</xsl:text>
			</xsl:if>
			<xsl:apply-templates select="." mode="complex-cartesian"/>
			<xsl:if test="not(position()=1)">
				<xsl:text>)</xsl:text>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="math:minus" name="complex-minus" mode="complex-cartesian">
		<xsl:for-each select="parent::math:apply/*[position()>1]">
			<xsl:if test="not(position()=1)">
				<xsl:text>.minus(</xsl:text>
			</xsl:if>
			<xsl:apply-templates select="." mode="complex-cartesian"/>
		</xsl:for-each>
		<xsl:text>)</xsl:text>
	</xsl:template>
	<xsl:template match="math:times" name="complex-times" mode="complex-cartesian">
		<xsl:for-each select="parent::math:apply/*[position()>1]">
			<xsl:if test="not(position()=1)">
				<xsl:text>.times(</xsl:text>
			</xsl:if>
			<xsl:apply-templates select="." mode="complex-cartesian"/>
			<xsl:if test="not(position()=1)">
				<xsl:text>)</xsl:text>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="math:power" mode="complex-cartesian">
		<xsl:text>com.pombi.mathml.lang.ComplexMath.pow(</xsl:text>
		<xsl:apply-templates select="parent::math:apply/*[2]" mode="complex-cartesian"/>
		<xsl:text>, </xsl:text>
		<xsl:apply-templates select="parent::math:apply/*[3]" mode="complex-cartesian"/>
		<xsl:text>)</xsl:text>
	</xsl:template>
	<xsl:template match="math:forall" name="complex-forall" mode="complex-cartesian">
		<xsl:variable name="var" select="translate(../child::math:bvar, ' ','')"/>
                for(;<xsl:apply-templates select="../*[name()='condition']" mode="complex-cartesian"/>;)
                {
		<xsl:for-each select="../*[name()='apply']">
                    <xsl:apply-templates select="." mode="complex-cartesian"/>;
		</xsl:for-each>
                }
        </xsl:template>
	<xsl:template match="math:condition" name="complex-condition" mode="complex-cartesian">
            <xsl:apply-templates select="./*" mode="complex-cartesian"/>
        </xsl:template>
	<xsl:template match="math:not" name="complex-not" mode="complex-cartesian">
            <xsl:text>!</xsl:text><xsl:apply-templates select="../*[2]" mode="complex-cartesian"/>
        </xsl:template>
	<xsl:template match="math:abs" name="complex-abs" mode="complex-cartesian">
            <xsl:text>com.pombi.mathml.lang.ComplexMath.abs(</xsl:text><xsl:apply-templates select="../*[2]" mode="complex-cartesian"/><xsl:text>)</xsl:text>
        </xsl:template>
	<xsl:template match="math:tendsto" name="complex-tendsto" mode="complex-cartesian">
            <xsl:variable name="direction" select="@type"/>
            <xsl:choose>
                <xsl:when test="../*[position()=3 and name()='infinity']">
                    <xsl:text>Double.isInfinite(</xsl:text><xsl:apply-templates select="../*[2]" mode="complex-cartesian"/><xsl:text>)</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates select="../*[2]" mode="complex-cartesian"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:template>

</xsl:stylesheet>